Imports System.IO
Imports FourViews.FourViewsDts

Public Class frmDetailView

   Private _DataFile As New FileInfo("..\..\FourViewsDts.xml")

   Private Sub MenuStrip1_MenuClicked(ByVal Sender As Object, ByVal e As EventArgs) _
      Handles SaveToolStripMenuItem.Click, ReloadToolStripMenuItem.Click, GenerateToolStripMenuItem.Click
      Select Case True
         Case Sender Is SaveToolStripMenuItem
            Save()

         Case Sender Is ReloadToolStripMenuItem
            Reload()

         Case Sender Is GenerateToolStripMenuItem
            Generate()

      End Select
   End Sub

   Private Sub Save()
      'Validate berprft alle aktuellen Control-Eingaben, und **bernimmt sie in die Datasource**. Letzteres ist wichtig, da ansonsten der User berrascht wird, weil seine letzte Eingabe gecancelt wrde.
      'AcceptChanges markiert alle Datenstze als bereinstimmend mit der "Datenbank" - wichtig fr den Dataset.HasChanges-Test im FormClosing
      Me.Validate()
      Me.FourViewsDts.WriteXml(_DataFile.FullName)
      FourViewsDts.AcceptChanges()
      Media.SystemSounds.Asterisk.Play()
   End Sub

   Private Sub Reload()
      Me.FourViewsDts.Clear()
      If _DataFile.Exists() Then
         Me.FourViewsDts.ReadXml(_DataFile.FullName)
      Else
         MessageBox.Show(String.Concat( _
            "Leider (noch) kein DatenFile vorhanden", Lf, _
            "Sie knnen aber trotzdem fortfahren, und eines anlegen."))
      End If
      FourViewsDts.AcceptChanges()
   End Sub

   Private Sub Generate()
      With FourViewsDts
         .Clear()
         For i = 0 To 6
            .Category.AddCategoryRow("Category" & i)
         Next
         For i = 0 To 6
            .Deliverer.AddDelivererRow("Deliverer" & i, "Deliverer" & i & "Address")
         Next
         Dim iArticle = 0
         For iCat = 0 To 3
            For iDeli = 2 To 6
               Dim rwCat = .Category(iCat)
               Dim rwDeli = .Deliverer(iDeli)
               Dim name = String.Join("_", "Article" & iArticle, iCat, iDeli)
               Dim price = 3D + CDec(iCat * iDeli) / 100
               .Article.AddArticleRow(name, price, rwCat, rwDeli)
               iArticle += 1
            Next
         Next
         For iCat = 2 To 6
            For iDeli = 0 To 3
               Dim rwCat = .Category(iCat)
               Dim rwDeli = .Deliverer(iDeli)
               Dim name = String.Join("_", "Article" & iArticle, iCat, iDeli)
               Dim price = 3D + CDec(iCat * iDeli) / 100
               .Article.AddArticleRow(name, price, rwCat, rwDeli)
               iArticle += 1
            Next
         Next
      End With
   End Sub

End Class